Subject: [bug#69899] [PATCH 0/7] support to use `guix system vm' with riscv64.

From: Ludovic Courtès <[email-masked]>
Date: Tue, 16 Apr 2024 19:04:41 +0200

Zheng Junjie <[email-masked]> skribis:

> Ludovic Courtès <[email-masked]> writes:

[...]

>> Thing is, ‘--system=X’ is supposed to be giving the exact same result as
>> if you were building natively on X.  Thus, it’s not surprising that
>> ‘guix system vm --system=X’ gives on a QEMU binary built for X.
>>
>> Now, it’s admittedly not very useful in this case.  I believe the
>> attached patch implements #1 (I wasn’t able to test it yet because too
>> many things had to be built).  How does it sound?
>
> it works,

Great, I’ll push it shortly.

> and the following patch is required.
>
> From e178de931859399abdd4bd3300b7ce7c5593a6e3 Mon Sep 17 00:00:00 2001
> Message-ID: <e17[email-masked]>
> From: Zheng Junjie <[email-masked]>
> Date: Tue, 2 Apr 2024 00:59:54 +0800
> Subject: [PATCH] vm: Don't add -enable-kvm when SYSTEM and %system are not
>  same.
>
> * gnu/system/vm.scm (common-qemu-options): Don't add -enable-kvm when SYSTEM
> and %system are not same.
>
> Change-Id: Ie6c602b297c39423a693fdc26bed1627266e5911

[...]

> +     #$@(if (and (not target)
> +                 (string=? system %system)
> +                 (file-exists? "/dev/kvm"))

I’m afraid this is too simple: we still want KVM when emulating i686 on
x86_64, or armhf on aarch64.

Does it really hurt to pass ‘-enable-kvm’?  Can you think of another
way?

Thanks,
Ludo’.